#include <systemc.h>
#include <assert.h>
#include "display.h"

////////////////////////////

// DISPLAY: SAVE ON A FILE DATA FROM THE SYSTEM

////////////////////////////

extern bool stop_concurrency_sampling;

void display::main()
{
	sys_results tmp1;
	FILE *outputFileHandle;

	// Open the file that will store the processed image 
	outputFileHandle = fopen("./IMG/out_image.txt", "w");

	while(1)
	{
		for(int rowIndex=0; rowIndex<SZ_ROW; rowIndex++) 
		{
			for(int colIndex=0; colIndex<SZ_COL; colIndex++)
			{
				// Read pixel from channel (from uat)
				tmp1=result_channel_port->read();
				// Write upper byte to file
				fprintf(outputFileHandle, "%d ", (int)(((char*)&tmp1.values)[0]) );
				// Write lower byte to file
				fprintf(outputFileHandle, "%d ", (int)(((char*)&tmp1.values)[1]) );
			}
			fprintf(outputFileHandle, "\n");
		}

		stop_concurrency_sampling = true; // LP

		cout << "Display: image received at time: " << sc_time_stamp().to_seconds() << endl;

		// Close the file that has the image stored in it (after all the pixels have been written)
		fclose(outputFileHandle);
	}
}
