#ifndef __DISPLAY__
#define __DISPLAY__

#include <systemc.h>
#include "sc_csp_channel_ifs.h"
#include "sc_csp_channel.h"
#include "datatype.h"
#include "define.h"

SC_MODULE(display)
{
	// Port for input by channel
  sc_port< sc_csp_channel_in_if< sys_results > > result_channel_port;

  SC_CTOR(display)
    {
      SC_THREAD(main);
    }

    // Main method
  void main();
};

#endif
